Package org.opentcs.drivers.vehicle

# Interface MovementCommand

    public interface MovementCommand

A command for moving a step.

- ## Field Summary

  Fields
  Modifier and Type | Field | Description
  --- | --- | ---
  `static java.lang.String` | `MOVE_OPERATION` | A constant indicating the vehicle should basically just move to a point without a location associated to it.
  `static java.lang.String` | `NO_OPERATION` | A constant indicating there is no operation to be executed after moving.
  `static java.lang.String` | `PARK_OPERATION` | A constant for parking the vehicle.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `Point` | `getFinalDestination()` | Returns the final destination of the drive order this MovementCommand was created for.
  `Location` | `getFinalDestinationLocation()` | Returns the destination location of the whole drive order.
  `java.lang.String` | `getFinalOperation()` | Returns the operation to be executed at the final destination position.
  `java.lang.String` | `getOperation()` | Returns the operation to be executed after moving.
  `Location` | `getOpLocation()` | Returns the location at which the operation is to be executed.
  `java.util.Map<java.lang.String,​java.lang.String>` | `getProperties()` | Returns the properties of the order this command is part of.
  `Route` | `getRoute()` | Returns the route that this movement belongs to.
  `Route.Step` | `getStep()` | Returns the step describing the movement.
  `boolean` | `isFinalMovement()` | Indicates whether this movement is the final one in the driver order it belongs to.
  `boolean` | `isWithoutOperation()` | Checks whether an operation is to be executed in addition to moving or not.

- ## Field Details

  - ### NO_OPERATION

    static final java.lang.String NO_OPERATION
    A constant indicating there is no operation to be executed after moving.
    See Also:
      Constant Field Values

  - ### MOVE_OPERATION

    static final java.lang.String MOVE_OPERATION
    A constant indicating the vehicle should basically just move to a point without a location associated to it.
    See Also:
      Constant Field Values

  - ### PARK_OPERATION

    static final java.lang.String PARK_OPERATION
    A constant for parking the vehicle. (Again, basically doing nothing at the destination.)
    See Also:
      Constant Field Values

- ## Method Details

  - ### getRoute

    @Nonnull Route getRoute()
    Returns the route that this movement belongs to.
    Returns:
      The route that this movement belongs to.

  - ### getStep

    @Nonnull Route.Step getStep()
    Returns the step describing the movement.
    Returns:
      The step describing the movement.

  - ### getOperation

    @Nonnull java.lang.String getOperation()
    Returns the operation to be executed after moving.
    Returns:
      The operation to be executed after moving.

  - ### isWithoutOperation

    boolean isWithoutOperation()
    Checks whether an operation is to be executed in addition to moving or not.
    Returns:
      `true` if, and only if, no operation is to be executed.

  - ### getOpLocation

    @Nullable Location getOpLocation()
    Returns the location at which the operation is to be executed. (May be `null` if operation is `NO_OPERATION`.)
    Returns:
      The location at which the operation is to be executed.

  - ### isFinalMovement

    boolean isFinalMovement()
    Indicates whether this movement is the final one in the driver order it belongs to.
    Returns:
      `true` if, and only if, this movement is the final one.

  - ### getFinalDestination

    @Nonnull Point getFinalDestination()
    Returns the final destination of the drive order this MovementCommand was created for.
    Returns:
      The final destination of the drive order this MovementCommand was created for.

  - ### getFinalDestinationLocation

    @Nullable Location getFinalDestinationLocation()
    Returns the destination location of the whole drive order.
    Returns:
      The destination location of the whole drive order.

  - ### getFinalOperation

    @Nonnull java.lang.String getFinalOperation()
    Returns the operation to be executed at the final destination position.
    Returns:
      The operation to be executed at the final destination position.

  - ### getProperties

    @Nonnull java.util.Map<java.lang.String,​java.lang.String> getProperties()
    Returns the properties of the order this command is part of.
    Returns:
      The properties of the order this command is part of.